﻿using System;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Xamarin.Forms;

namespace Sample
{
    // Learn more about making custom code visible in the Xamarin.Forms previewer
    // by visiting https://aka.ms/xamarinforms-previewer
    [DesignTimeVisible(false)]
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();

            BindingContext = new ViewModel();
        }
    }

    public class ViewModel:BaseModel
    {
        public List<Model> CarriageMotorCfg { set; get; }
        //public ICommand IncrementCommand { set; get; }

        public ViewModel()
        {
            List<Model> list = new List<Model>();
            for (int i=0; i<10; i++)
            {
                list.Add(new Model { BtnImageSource = "draw.png" });
            }
            CarriageMotorCfg = list;

            //IncrementCommand = new Command<string>((parameter) =>
            //{

            //});
        }
    }

    public class Model:BaseModel
    {
        public Model()
        {
            //IncrementCommand = new Command<string>((parameter) =>
            //{

            //});
        }

        public string BtnImageSource { set; get; }
        
        public string MotorCountString { set; get; }
    }

	public class BaseModel: INotifyPropertyChanged
	{
		ICommand _incrementCommand;

		public event PropertyChangedEventHandler PropertyChanged;

		internal bool ProcPropertyChanged<T>(ref T currentValue, T newValue, [CallerMemberName] string propertyName = "")
		{
			return PropertyChanged.SetProperty(this, ref currentValue, newValue, propertyName);
		}
		internal void ProcPropertyChanged(string propertyName)
		{
			try
			{
				// took out the ? for testing
				PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
			}
			catch (Exception ex)
			{
				System.Diagnostics.Debug.WriteLine(ex.ToString());
				throw;
			}
		}

		public ICommand IncrementCommand
		{
			get
			{
				return _incrementCommand ?? (
						_incrementCommand = new RelayCommand((object prop) =>

						{
							String propertyName = (String)prop;

							PropertyInfo pinfo = this.GetType().GetProperty(propertyName);

							String currentValue = (String)pinfo.GetValue(this);


							UInt16 temp = 0; // _propertyMinimums[propertyName];
							if (UInt16.TryParse(currentValue, out temp))
							{
								//if (temp < _propertyMaximums[propertyName])
									temp++;
							}

							pinfo.SetValue(this, temp.ToString());
						},
						(object prop) =>
						{
							// Grab the property name
							String propertyName = ((String)prop);
							PropertyInfo pinfo = this.GetType().GetProperty(propertyName);

							// All distances are bytes
							String currentValue = (String)pinfo.GetValue(this);

							UInt16 temp = 0; // _propertyMinimums[propertyName];
							UInt16.TryParse(currentValue, out temp);

							// Increment is enabled if cur < max
							return true; // temp < _propertyMaximums[propertyName];
						},

																this));
			}
		}

	}

	public class RelayCommand : Command
	{
		public RelayCommand(Action<object> execute)
			: base(execute)
		{
		}

		public RelayCommand(Action execute)
			: this(o => execute())
		{
		}

		public RelayCommand(Action<object> execute, Func<object, bool> canExecute, INotifyPropertyChanged npc = null)
			: base(execute, canExecute)
		{
			if (npc != null)
				npc.PropertyChanged += delegate { ChangeCanExecute(); };
		}

		public RelayCommand(Action execute, Func<bool> canExecute, INotifyPropertyChanged npc = null)
			: this(o => execute(), o => canExecute(), npc)
		{
		}

		public void RaiseChangeCanExecute()
		{
			ChangeCanExecute();
		}
	}
}
